#ifndef BSPLINE
#define BSPLINE

#include <GL/gl.h>
#include "myMath.h"

typedef struct Sbspline *Bspline;

/* Création d'une courbe B-Spline à vecteur nodal uniforme */
Bspline creerBsplineUniforme (GLfloat *ptsControle, int nbPtsControle, int k);

/* Création d'une courbe B-Spline à vecteur nodal ouvert uniforme */
Bspline creerBsplineOuvertUniforme (GLfloat *ptsControle, int nbPtsControle, int k);

/* Calcul d'un point p(u) stocké dans p */
void evalBspline (Bspline b, float u, Point p);

/* Calcul des points et du tableau d'index pour le tracer OpenGL d'une courbe B-Spline */
void calculCourbeBspline (Bspline b, int nbPtsCourbe);

/* Affichage OpenGL du polygone de controle de la courbe */
void affichePolyControleBspline (Bspline b);

/* Affichage OpenGL des points de la courbe (attention, ces points doivent avoir été calculés) */
void afficheCourbeBspline (Bspline b);

/* retourne dans def les bornes de l'intervalle de définition */
void intervalleDefinitionBspline (Bspline b, float def[2]);

#endif
