#include "bsplinesurface.h"
#include "bspline.h"
#include <malloc.h>
#include <stdio.h>


struct SsurfaceBspline {
  
  /* a compléter */
  
  int nbPtsControleU; /* Nombre du points en U du maillage controle de la surface */
  int nbPtsControleV; /* Nombre du points en V du maillage controle de la surface */
  GLfloat *ptsControle; /* Points du maillage de controle */
  int nbPtsControle;
  GLuint *indexMaillageControle; /* Tableau d'index pour afficher le maillage de controle avec des quadrilatères */
  int nbIndexControle;
  
  
  int nbPtsU; /* nombre de points du maillage de la surface en u */
  int nbPtsV; /* nombre de points du maillage de la surface en v */
  GLfloat *ptsMaillage; /* Points du maillage représentant la surface */
  int nbPtsMaillage;
  GLfloat *normalesMaillage; /* Normales aux points du maillage représentant la surface */
  GLuint *indexMaillage; /* Tableau d'index pour mailler les points du maillages avec des quadrilatères */
  int nbIndexMaillage;
  
  
  Bspline *directrices;
  GLfloat *controleGeneratrice;
  
  int k; /* ordre des B-Splines */
  int type; /* vecteur nodal uniforme : type = 0, vecteur nodal ouvert uniforme : type = 1 */
  float defU[2];
  float defV[2];
};



void evalSurfaceBspline (SurfaceBspline s, float u, float v, Point p) {

 /* Code de calcul d'un point p(u,v) par produit tensoriel */
 
 /* A Ecrire !!!!!! */
 
}


void maillePointsQuad (int nbPtsControleU, int nbPtsControleV, GLuint *index) {

 /* Code de construction du tableau d'index pour le rendu OpenGL par quadrilatères */
 
 /* A Ecrire !!!!!! */
 
}


void calculNormalesMaillageSurfaceBspline (SurfaceBspline s) {

 /* Code de calcul des normales par sommet */
 
 /* A Ecrire !!!!!! */
 
}

void calculMaillageSurfaceBspline (SurfaceBspline s, int nbPtsU, int nbPtsV){

 /* Code de calcul des points du maillage pour l'affichage du carreau paramétrique.
    Ce programme se termine par les deux lignes ci-dessous qui construisent le tableau 
    d'index pour le rendu OpenGL par quadrilatères et calcul les normales par sommet.
    Ces deux fonctions sont aussi à écrire. */
 
 /* A Ecrire !!!!!! */

    
  maillePointsQuad (nbPtsU, nbPtsV, s->indexMaillage);
  calculNormalesMaillageSurfaceBspline (s);
}


SurfaceBspline creerSurfaceBsplineUniforme (GLfloat *ptsControle, int nbPtsControleU, int nbPtsControleV, int k, int type) {
  
  SurfaceBspline s = (SurfaceBspline) malloc (sizeof(struct SsurfaceBspline));
  int i;
  
  s->k=k;
  s->type = type;
  
  s->nbPtsControleU = nbPtsControleU;
  s->nbPtsControleV = nbPtsControleV;
  s->nbPtsControle = nbPtsControleU*nbPtsControleV;
  s->nbIndexControle = (nbPtsControleU-1)*(nbPtsControleV-1)*4;
  
  s->ptsControle = (GLfloat *)malloc(sizeof(GLfloat)*s->nbPtsControle*3);
  for (i=0;i<s->nbPtsControle*3;i++) s->ptsControle[i] = ptsControle[i];
  
  s->indexMaillageControle = (GLuint*)malloc(sizeof(GLuint)*s->nbIndexControle);
  maillePointsQuad (s->nbPtsControleU, s->nbPtsControleV, s->indexMaillageControle);
  
  s->directrices = (Bspline*)malloc(sizeof(Bspline)*nbPtsControleV);
  for (i=0;i<nbPtsControleV;i++) {
    if (s->type) s->directrices[i] = creerBsplineOuvertUniforme(ptsControle+i*nbPtsControleU*3, nbPtsControleU, k);
      else s->directrices[i] = creerBsplineUniforme(ptsControle+i*nbPtsControleU*3, nbPtsControleU, k);
  }
  
  s->controleGeneratrice = (GLfloat*)malloc(sizeof(GLfloat)*nbPtsControleV*3);
  
  return s;
}


/* affichage du polygone de contrôle en filaire */
void affichePolyControleSurfaceBspline (SurfaceBspline s){

    glEnableClientState(GL_VERTEX_ARRAY);
    glVertexPointer(3,GL_FLOAT,0,s->ptsControle);
    glDrawElements(GL_QUADS,s->nbIndexControle,GL_UNSIGNED_INT,s->indexMaillageControle);
    glDisableClientState(GL_VERTEX_ARRAY);
 
}

void afficheSurfaceBspline (SurfaceBspline s){
  float specular [] = {0.9,0.9,0.9,1.};
  float shininess = 70.;
	
    glEnable(GL_COLOR_MATERIAL);
    glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);

    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, specular);
    glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, shininess);

    glEnableClientState(GL_VERTEX_ARRAY);
    glVertexPointer(3,GL_FLOAT,0,s->ptsMaillage);
    glEnableClientState(GL_NORMAL_ARRAY);
    glNormalPointer(GL_FLOAT, 0, s->normalesMaillage);
    glDrawElements(GL_QUADS,(s->nbPtsU-1)*(s->nbPtsV-1)*4,GL_UNSIGNED_INT,s->indexMaillage);
    glDisableClientState(GL_VERTEX_ARRAY);
    glDisableClientState(GL_NORMAL_ARRAY);
	
    glDisable(GL_COLOR_MATERIAL);
  
}



